/*
 * Copyright (c) 2018 Cisco and/or its affiliates.
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at:
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

#ifndef __BIER_FWD_H__
#define __BIER_FWD_H__

#include <vnet/bier/bier_types.h>
#include <vnet/bier/bier_hdr_inlines.h>

static_always_inline u32
bier_compute_flow_hash (const bier_hdr_t *hdr)
{
    u32 first_word = clib_net_to_host_u32(hdr->bh_first_word);

    return ((first_word &
             BIER_HDR_ENTROPY_FIELD_MASK) >>
            BIER_HDR_ENTROPY_FIELD_SHIFT);
}

#endif
