#ifndef included_ipsec_api_enum_h
#define included_ipsec_api_enum_h
typedef enum {
   VL_API_IPSEC_SPD_ADD_DEL,
   VL_API_IPSEC_SPD_ADD_DEL_REPLY,
   VL_API_IPSEC_INTERFACE_ADD_DEL_SPD,
   VL_API_IPSEC_INTERFACE_ADD_DEL_SPD_REPLY,
   VL_API_IPSEC_SPD_ENTRY_ADD_DEL,
   VL_API_IPSEC_SPD_ENTRY_ADD_DEL_V2,
   VL_API_IPSEC_SPD_ENTRY_ADD_DEL_REPLY,
   VL_API_IPSEC_SPD_ENTRY_ADD_DEL_V2_REPLY,
   VL_API_IPSEC_SPDS_DUMP,
   VL_API_IPSEC_SPDS_DETAILS,
   VL_API_IPSEC_SPD_DUMP,
   VL_API_IPSEC_SPD_DETAILS,
   VL_API_IPSEC_SAD_ENTRY_ADD_DEL,
   VL_API_IPSEC_SAD_ENTRY_ADD_DEL_V2,
   VL_API_IPSEC_SAD_ENTRY_ADD_DEL_V3,
   VL_API_IPSEC_SAD_ENTRY_ADD,
   VL_API_IPSEC_SAD_ENTRY_ADD_V2,
   VL_API_IPSEC_SAD_ENTRY_DEL,
   VL_API_IPSEC_SAD_ENTRY_DEL_REPLY,
   VL_API_IPSEC_SAD_BIND,
   VL_API_IPSEC_SAD_BIND_REPLY,
   VL_API_IPSEC_SAD_UNBIND,
   VL_API_IPSEC_SAD_UNBIND_REPLY,
   VL_API_IPSEC_SAD_ENTRY_UPDATE,
   VL_API_IPSEC_SAD_ENTRY_UPDATE_REPLY,
   VL_API_IPSEC_SAD_ENTRY_ADD_DEL_REPLY,
   VL_API_IPSEC_SAD_ENTRY_ADD_DEL_V2_REPLY,
   VL_API_IPSEC_SAD_ENTRY_ADD_DEL_V3_REPLY,
   VL_API_IPSEC_SAD_ENTRY_ADD_REPLY,
   VL_API_IPSEC_SAD_ENTRY_ADD_V2_REPLY,
   VL_API_IPSEC_TUNNEL_PROTECT_UPDATE,
   VL_API_IPSEC_TUNNEL_PROTECT_UPDATE_REPLY,
   VL_API_IPSEC_TUNNEL_PROTECT_DEL,
   VL_API_IPSEC_TUNNEL_PROTECT_DEL_REPLY,
   VL_API_IPSEC_TUNNEL_PROTECT_DUMP,
   VL_API_IPSEC_TUNNEL_PROTECT_DETAILS,
   VL_API_IPSEC_SPD_INTERFACE_DUMP,
   VL_API_IPSEC_SPD_INTERFACE_DETAILS,
   VL_API_IPSEC_ITF_CREATE,
   VL_API_IPSEC_ITF_CREATE_REPLY,
   VL_API_IPSEC_ITF_DELETE,
   VL_API_IPSEC_ITF_DELETE_REPLY,
   VL_API_IPSEC_ITF_DUMP,
   VL_API_IPSEC_ITF_DETAILS,
   VL_API_IPSEC_SA_DUMP,
   VL_API_IPSEC_SA_V2_DUMP,
   VL_API_IPSEC_SA_V3_DUMP,
   VL_API_IPSEC_SA_V4_DUMP,
   VL_API_IPSEC_SA_V5_DUMP,
   VL_API_IPSEC_SA_DETAILS,
   VL_API_IPSEC_SA_V2_DETAILS,
   VL_API_IPSEC_SA_V3_DETAILS,
   VL_API_IPSEC_SA_V4_DETAILS,
   VL_API_IPSEC_SA_V5_DETAILS,
   VL_API_IPSEC_BACKEND_DUMP,
   VL_API_IPSEC_BACKEND_DETAILS,
   VL_API_IPSEC_SELECT_BACKEND,
   VL_API_IPSEC_SELECT_BACKEND_REPLY,
   VL_API_IPSEC_SET_ASYNC_MODE,
   VL_API_IPSEC_SET_ASYNC_MODE_REPLY,
   VL_MSG_IPSEC_LAST
} vl_api_ipsec_enum_t;
typedef enum {
   ESP_DECRYPT_ERROR_RX_PKTS,
   ESP_DECRYPT_ERROR_RX_POST_PKTS,
   ESP_DECRYPT_ERROR_HANDOFF,
   ESP_DECRYPT_ERROR_DECRYPTION_FAILED,
   ESP_DECRYPT_ERROR_INTEG_ERROR,
   ESP_DECRYPT_ERROR_CRYPTO_ENGINE_ERROR,
   ESP_DECRYPT_ERROR_REPLAY,
   ESP_DECRYPT_ERROR_RUNT,
   ESP_DECRYPT_ERROR_NO_BUFFERS,
   ESP_DECRYPT_ERROR_OVERSIZED_HEADER,
   ESP_DECRYPT_ERROR_NO_TAIL_SPACE,
   ESP_DECRYPT_ERROR_TUN_NO_PROTO,
   ESP_DECRYPT_ERROR_UNSUP_PAYLOAD,
   ESP_DECRYPT_ERROR_NO_AVAIL_FRAME,
   ESP_DECRYPT_N_ERROR
} vl_counter_esp_decrypt_enum_t;
extern vlib_error_desc_t esp_decrypt_error_counters[];
typedef enum {
   ESP_ENCRYPT_ERROR_RX_PKTS,
   ESP_ENCRYPT_ERROR_POST_RX_PKTS,
   ESP_ENCRYPT_ERROR_HANDOFF,
   ESP_ENCRYPT_ERROR_SEQ_CYCLED,
   ESP_ENCRYPT_ERROR_CRYPTO_ENGINE_ERROR,
   ESP_ENCRYPT_ERROR_CRYPTO_QUEUE_FULL,
   ESP_ENCRYPT_ERROR_NO_BUFFERS,
   ESP_ENCRYPT_ERROR_NO_PROTECTION,
   ESP_ENCRYPT_ERROR_NO_ENCRYPTION,
   ESP_ENCRYPT_ERROR_NO_AVAIL_FRAME,
   ESP_ENCRYPT_N_ERROR
} vl_counter_esp_encrypt_enum_t;
extern vlib_error_desc_t esp_encrypt_error_counters[];
typedef enum {
   AH_ENCRYPT_ERROR_RX_PKTS,
   AH_ENCRYPT_ERROR_CRYPTO_ENGINE_ERROR,
   AH_ENCRYPT_ERROR_SEQ_CYCLED,
   AH_ENCRYPT_N_ERROR
} vl_counter_ah_encrypt_enum_t;
extern vlib_error_desc_t ah_encrypt_error_counters[];
typedef enum {
   AH_DECRYPT_ERROR_RX_PKTS,
   AH_DECRYPT_ERROR_DECRYPTION_FAILED,
   AH_DECRYPT_ERROR_INTEG_ERROR,
   AH_DECRYPT_ERROR_NO_TAIL_SPACE,
   AH_DECRYPT_ERROR_DROP_FRAGMENTS,
   AH_DECRYPT_ERROR_REPLAY,
   AH_DECRYPT_N_ERROR
} vl_counter_ah_decrypt_enum_t;
extern vlib_error_desc_t ah_decrypt_error_counters[];
typedef enum {
   IPSEC_TUN_ERROR_RX,
   IPSEC_TUN_ERROR_DISABLED,
   IPSEC_TUN_ERROR_NO_TUNNEL,
   IPSEC_TUN_ERROR_TUNNEL_MISMATCH,
   IPSEC_TUN_ERROR_NAT_KEEPALIVE,
   IPSEC_TUN_ERROR_TOO_SHORT,
   IPSEC_TUN_ERROR_SPI_0,
   IPSEC_TUN_N_ERROR
} vl_counter_ipsec_tun_enum_t;
extern vlib_error_desc_t ipsec_tun_error_counters[];
#endif
