#ifndef included_af_xdp_api_types_h
#define included_af_xdp_api_types_h
#define VL_API_AF_XDP_API_VERSION_MAJOR 1
#define VL_API_AF_XDP_API_VERSION_MINOR 0
#define VL_API_AF_XDP_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/interface_types.api_types.h>
typedef enum {
    AF_XDP_API_MODE_AUTO = 0,
    AF_XDP_API_MODE_COPY = 1,
    AF_XDP_API_MODE_ZERO_COPY = 2,
} vl_api_af_xdp_mode_t;
typedef enum __attribute__((packed)) {
    AF_XDP_API_FLAGS_NO_SYSCALL_LOCK = 1,
} vl_api_af_xdp_flag_t;
STATIC_ASSERT(sizeof(vl_api_af_xdp_flag_t) == sizeof(u8), "size of API enum af_xdp_flag is wrong");
typedef struct __attribute__ ((packed)) _vl_api_af_xdp_create {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 host_if[64];
    u8 name[64];
    u16 rxq_num;
    u16 rxq_size;
    u16 txq_size;
    vl_api_af_xdp_mode_t mode;
    vl_api_af_xdp_flag_t flags;
    u8 prog[256];
} vl_api_af_xdp_create_t;
#define VL_API_AF_XDP_CREATE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_af_xdp_create_v2 {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 host_if[64];
    u8 name[64];
    u16 rxq_num;
    u16 rxq_size;
    u16 txq_size;
    vl_api_af_xdp_mode_t mode;
    vl_api_af_xdp_flag_t flags;
    u8 prog[256];
    u8 namespace[64];
} vl_api_af_xdp_create_v2_t;
#define VL_API_AF_XDP_CREATE_V2_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_af_xdp_create_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_interface_index_t sw_if_index;
} vl_api_af_xdp_create_reply_t;
#define VL_API_AF_XDP_CREATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_af_xdp_create_v2_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_interface_index_t sw_if_index;
} vl_api_af_xdp_create_v2_reply_t;
#define VL_API_AF_XDP_CREATE_V2_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_af_xdp_create_v3 {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 host_if[64];
    u8 name[64];
    u16 rxq_num;
    u16 rxq_size;
    u16 txq_size;
    vl_api_af_xdp_mode_t mode;
    vl_api_af_xdp_flag_t flags;
    u8 prog[256];
    u8 netns[64];
} vl_api_af_xdp_create_v3_t;
#define VL_API_AF_XDP_CREATE_V3_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_af_xdp_create_v3_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_interface_index_t sw_if_index;
} vl_api_af_xdp_create_v3_reply_t;
#define VL_API_AF_XDP_CREATE_V3_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_af_xdp_delete {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_interface_index_t sw_if_index;
} vl_api_af_xdp_delete_t;
#define VL_API_AF_XDP_DELETE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_af_xdp_delete_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_af_xdp_delete_reply_t;
#define VL_API_AF_XDP_DELETE_REPLY_IS_CONSTANT_SIZE (1)

#define VL_API_AF_XDP_CREATE_CRC "af_xdp_create_21226c99"
#define VL_API_AF_XDP_CREATE_V2_CRC "af_xdp_create_v2_e17ec2eb"
#define VL_API_AF_XDP_CREATE_REPLY_CRC "af_xdp_create_reply_5383d31f"
#define VL_API_AF_XDP_CREATE_V2_REPLY_CRC "af_xdp_create_v2_reply_5383d31f"
#define VL_API_AF_XDP_CREATE_V3_CRC "af_xdp_create_v3_cf4b1827"
#define VL_API_AF_XDP_CREATE_V3_REPLY_CRC "af_xdp_create_v3_reply_5383d31f"
#define VL_API_AF_XDP_DELETE_CRC "af_xdp_delete_f9e6675e"
#define VL_API_AF_XDP_DELETE_REPLY_CRC "af_xdp_delete_reply_e8d4e804"

#endif
