#ifndef included_nat44_ed_api_types_h
#define included_nat44_ed_api_types_h
#define VL_API_NAT44_ED_API_VERSION_MAJOR 5
#define VL_API_NAT44_ED_API_VERSION_MINOR 5
#define VL_API_NAT44_ED_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/ip/ip_types.api_types.h>
#include <vnet/interface_types.api_types.h>
#include <nat/lib/nat_types.api_types.h>
typedef enum __attribute__((packed)) {
    NAT44_IS_ENDPOINT_INDEPENDENT = 0,
    NAT44_IS_ENDPOINT_DEPENDENT = 1,
    NAT44_IS_STATIC_MAPPING_ONLY = 2,
    NAT44_IS_CONNECTION_TRACKING = 4,
    NAT44_IS_OUT2IN_DPO = 8,
} vl_api_nat44_config_flags_t;
STATIC_ASSERT(sizeof(vl_api_nat44_config_flags_t) == sizeof(u8), "size of API enum nat44_config_flags is wrong");
typedef struct __attribute__ ((packed)) _vl_api_nat44_lb_addr_port {
    vl_api_ip4_address_t addr;
    u16 port;
    u8 probability;
    u32 vrf_id;
} vl_api_nat44_lb_addr_port_t;
#define VL_API_NAT44_LB_ADDR_PORT_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_plugin_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 inside_vrf;
    u32 outside_vrf;
    u32 sessions;
    u32 session_memory;
    bool enable;
    vl_api_nat44_config_flags_t flags;
} vl_api_nat44_ed_plugin_enable_disable_t;
#define VL_API_NAT44_ED_PLUGIN_ENABLE_DISABLE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_plugin_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_ed_plugin_enable_disable_reply_t;
#define VL_API_NAT44_ED_PLUGIN_ENABLE_DISABLE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_forwarding_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool enable;
} vl_api_nat44_forwarding_enable_disable_t;
#define VL_API_NAT44_FORWARDING_ENABLE_DISABLE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_forwarding_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_forwarding_enable_disable_reply_t;
#define VL_API_NAT44_FORWARDING_ENABLE_DISABLE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_ipfix_enable_disable {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 domain_id;
    u16 src_port;
    bool enable;
} vl_api_nat_ipfix_enable_disable_t;
#define VL_API_NAT_IPFIX_ENABLE_DISABLE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_ipfix_enable_disable_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat_ipfix_enable_disable_reply_t;
#define VL_API_NAT_IPFIX_ENABLE_DISABLE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_set_timeouts {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 udp;
    u32 tcp_established;
    u32 tcp_transitory;
    u32 icmp;
} vl_api_nat_set_timeouts_t;
#define VL_API_NAT_SET_TIMEOUTS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_set_timeouts_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat_set_timeouts_reply_t;
#define VL_API_NAT_SET_TIMEOUTS_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_set_session_limit {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 session_limit;
    u32 vrf_id;
} vl_api_nat44_set_session_limit_t;
#define VL_API_NAT44_SET_SESSION_LIMIT_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_set_session_limit_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_set_session_limit_reply_t;
#define VL_API_NAT44_SET_SESSION_LIMIT_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_show_running_config {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_show_running_config_t;
#define VL_API_NAT44_SHOW_RUNNING_CONFIG_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_show_running_config_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 inside_vrf;
    u32 outside_vrf;
    u32 users;
    u32 sessions;
    u32 user_sessions;
    u32 user_buckets;
    u32 translation_buckets;
    bool forwarding_enabled;
    bool ipfix_logging_enabled;
    vl_api_nat_timeouts_t timeouts;
    vl_api_nat_log_level_t log_level;
    vl_api_nat44_config_flags_t flags;
} vl_api_nat44_show_running_config_reply_t;
#define VL_API_NAT44_SHOW_RUNNING_CONFIG_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_set_workers {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u64 worker_mask;
} vl_api_nat_set_workers_t;
#define VL_API_NAT_SET_WORKERS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_set_workers_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat_set_workers_reply_t;
#define VL_API_NAT_SET_WORKERS_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_worker_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat_worker_dump_t;
#define VL_API_NAT_WORKER_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_worker_details {
    u16 _vl_msg_id;
    u32 context;
    u32 worker_index;
    u32 lcore_id;
    u8 name[64];
} vl_api_nat_worker_details_t;
#define VL_API_NAT_WORKER_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_add_del_vrf_table {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 table_vrf_id;
    bool is_add;
} vl_api_nat44_ed_add_del_vrf_table_t;
#define VL_API_NAT44_ED_ADD_DEL_VRF_TABLE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_add_del_vrf_table_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_ed_add_del_vrf_table_reply_t;
#define VL_API_NAT44_ED_ADD_DEL_VRF_TABLE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_add_del_vrf_route {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 table_vrf_id;
    u32 vrf_id;
    bool is_add;
} vl_api_nat44_ed_add_del_vrf_route_t;
#define VL_API_NAT44_ED_ADD_DEL_VRF_ROUTE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_add_del_vrf_route_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_ed_add_del_vrf_route_reply_t;
#define VL_API_NAT44_ED_ADD_DEL_VRF_ROUTE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_vrf_tables_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_ed_vrf_tables_dump_t;
#define VL_API_NAT44_ED_VRF_TABLES_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_vrf_tables_details {
    u16 _vl_msg_id;
    u32 context;
    u32 table_vrf_id;
    u32 n_vrf_ids;
    u32 vrf_ids[0];
} vl_api_nat44_ed_vrf_tables_details_t;
#define VL_API_NAT44_ED_VRF_TABLES_DETAILS_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_vrf_tables_v2_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_ed_vrf_tables_v2_dump_t;
#define VL_API_NAT44_ED_VRF_TABLES_V2_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_vrf_tables_v2_details {
    u16 _vl_msg_id;
    u32 context;
    u32 table_vrf_id;
    u32 n_vrf_ids;
    u32 vrf_ids[0];
} vl_api_nat44_ed_vrf_tables_v2_details_t;
#define VL_API_NAT44_ED_VRF_TABLES_V2_DETAILS_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_nat_set_mss_clamping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u16 mss_value;
    bool enable;
} vl_api_nat_set_mss_clamping_t;
#define VL_API_NAT_SET_MSS_CLAMPING_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_set_mss_clamping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat_set_mss_clamping_reply_t;
#define VL_API_NAT_SET_MSS_CLAMPING_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_get_mss_clamping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat_get_mss_clamping_t;
#define VL_API_NAT_GET_MSS_CLAMPING_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat_get_mss_clamping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u16 mss_value;
    bool enable;
} vl_api_nat_get_mss_clamping_reply_t;
#define VL_API_NAT_GET_MSS_CLAMPING_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_set_fq_options {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 frame_queue_nelts;
} vl_api_nat44_ed_set_fq_options_t;
#define VL_API_NAT44_ED_SET_FQ_OPTIONS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_set_fq_options_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_ed_set_fq_options_reply_t;
#define VL_API_NAT44_ED_SET_FQ_OPTIONS_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_show_fq_options {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_ed_show_fq_options_t;
#define VL_API_NAT44_ED_SHOW_FQ_OPTIONS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_show_fq_options_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 frame_queue_nelts;
} vl_api_nat44_ed_show_fq_options_reply_t;
#define VL_API_NAT44_ED_SHOW_FQ_OPTIONS_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_interface_addr {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    vl_api_interface_index_t sw_if_index;
    vl_api_nat_config_flags_t flags;
} vl_api_nat44_add_del_interface_addr_t;
#define VL_API_NAT44_ADD_DEL_INTERFACE_ADDR_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_interface_addr_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_add_del_interface_addr_reply_t;
#define VL_API_NAT44_ADD_DEL_INTERFACE_ADDR_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_interface_addr_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_interface_addr_dump_t;
#define VL_API_NAT44_INTERFACE_ADDR_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_interface_addr_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_interface_index_t sw_if_index;
    vl_api_nat_config_flags_t flags;
} vl_api_nat44_interface_addr_details_t;
#define VL_API_NAT44_INTERFACE_ADDR_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_address_range {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_ip4_address_t first_ip_address;
    vl_api_ip4_address_t last_ip_address;
    u32 vrf_id;
    bool is_add;
    vl_api_nat_config_flags_t flags;
} vl_api_nat44_add_del_address_range_t;
#define VL_API_NAT44_ADD_DEL_ADDRESS_RANGE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_address_range_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_add_del_address_range_reply_t;
#define VL_API_NAT44_ADD_DEL_ADDRESS_RANGE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_address_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_address_dump_t;
#define VL_API_NAT44_ADDRESS_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_address_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_ip4_address_t ip_address;
    vl_api_nat_config_flags_t flags;
    u32 vrf_id;
} vl_api_nat44_address_details_t;
#define VL_API_NAT44_ADDRESS_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_interface_add_del_feature {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    vl_api_nat_config_flags_t flags;
    vl_api_interface_index_t sw_if_index;
} vl_api_nat44_interface_add_del_feature_t;
#define VL_API_NAT44_INTERFACE_ADD_DEL_FEATURE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_interface_add_del_feature_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_interface_add_del_feature_reply_t;
#define VL_API_NAT44_INTERFACE_ADD_DEL_FEATURE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_interface_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_interface_dump_t;
#define VL_API_NAT44_INTERFACE_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_interface_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_nat_config_flags_t flags;
    vl_api_interface_index_t sw_if_index;
} vl_api_nat44_interface_details_t;
#define VL_API_NAT44_INTERFACE_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_add_del_output_interface {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    vl_api_interface_index_t sw_if_index;
} vl_api_nat44_ed_add_del_output_interface_t;
#define VL_API_NAT44_ED_ADD_DEL_OUTPUT_INTERFACE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_add_del_output_interface_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_ed_add_del_output_interface_reply_t;
#define VL_API_NAT44_ED_ADD_DEL_OUTPUT_INTERFACE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_output_interface_get {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u32 cursor;
} vl_api_nat44_ed_output_interface_get_t;
#define VL_API_NAT44_ED_OUTPUT_INTERFACE_GET_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_output_interface_get_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    u32 cursor;
} vl_api_nat44_ed_output_interface_get_reply_t;
#define VL_API_NAT44_ED_OUTPUT_INTERFACE_GET_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_ed_output_interface_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_interface_index_t sw_if_index;
} vl_api_nat44_ed_output_interface_details_t;
#define VL_API_NAT44_ED_OUTPUT_INTERFACE_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_static_mapping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    vl_api_nat_config_flags_t flags;
    vl_api_ip4_address_t local_ip_address;
    vl_api_ip4_address_t external_ip_address;
    u8 protocol;
    u16 local_port;
    u16 external_port;
    vl_api_interface_index_t external_sw_if_index;
    u32 vrf_id;
    u8 tag[64];
} vl_api_nat44_add_del_static_mapping_t;
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_static_mapping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_add_del_static_mapping_reply_t;
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_static_mapping_v2 {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    bool match_pool;
    vl_api_nat_config_flags_t flags;
    vl_api_ip4_address_t pool_ip_address;
    vl_api_ip4_address_t local_ip_address;
    vl_api_ip4_address_t external_ip_address;
    u8 protocol;
    u16 local_port;
    u16 external_port;
    vl_api_interface_index_t external_sw_if_index;
    u32 vrf_id;
    u8 tag[64];
} vl_api_nat44_add_del_static_mapping_v2_t;
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_V2_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_static_mapping_v2_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_add_del_static_mapping_v2_reply_t;
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_V2_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_static_mapping_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_static_mapping_dump_t;
#define VL_API_NAT44_STATIC_MAPPING_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_static_mapping_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_nat_config_flags_t flags;
    vl_api_ip4_address_t local_ip_address;
    vl_api_ip4_address_t external_ip_address;
    u8 protocol;
    u16 local_port;
    u16 external_port;
    vl_api_interface_index_t external_sw_if_index;
    u32 vrf_id;
    u8 tag[64];
} vl_api_nat44_static_mapping_details_t;
#define VL_API_NAT44_STATIC_MAPPING_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_identity_mapping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    vl_api_nat_config_flags_t flags;
    vl_api_ip4_address_t ip_address;
    u8 protocol;
    u16 port;
    vl_api_interface_index_t sw_if_index;
    u32 vrf_id;
    u8 tag[64];
} vl_api_nat44_add_del_identity_mapping_t;
#define VL_API_NAT44_ADD_DEL_IDENTITY_MAPPING_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_identity_mapping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_add_del_identity_mapping_reply_t;
#define VL_API_NAT44_ADD_DEL_IDENTITY_MAPPING_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_identity_mapping_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_identity_mapping_dump_t;
#define VL_API_NAT44_IDENTITY_MAPPING_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_identity_mapping_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_nat_config_flags_t flags;
    vl_api_ip4_address_t ip_address;
    u8 protocol;
    u16 port;
    vl_api_interface_index_t sw_if_index;
    u32 vrf_id;
    u8 tag[64];
} vl_api_nat44_identity_mapping_details_t;
#define VL_API_NAT44_IDENTITY_MAPPING_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_lb_static_mapping {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    vl_api_nat_config_flags_t flags;
    vl_api_ip4_address_t external_addr;
    u16 external_port;
    u8 protocol;
    u32 affinity;
    u8 tag[64];
    u32 local_num;
    vl_api_nat44_lb_addr_port_t locals[0];
} vl_api_nat44_add_del_lb_static_mapping_t;
#define VL_API_NAT44_ADD_DEL_LB_STATIC_MAPPING_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_nat44_add_del_lb_static_mapping_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_add_del_lb_static_mapping_reply_t;
#define VL_API_NAT44_ADD_DEL_LB_STATIC_MAPPING_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_lb_static_mapping_add_del_local {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    bool is_add;
    vl_api_ip4_address_t external_addr;
    u16 external_port;
    u8 protocol;
    vl_api_nat44_lb_addr_port_t local;
} vl_api_nat44_lb_static_mapping_add_del_local_t;
#define VL_API_NAT44_LB_STATIC_MAPPING_ADD_DEL_LOCAL_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_lb_static_mapping_add_del_local_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_lb_static_mapping_add_del_local_reply_t;
#define VL_API_NAT44_LB_STATIC_MAPPING_ADD_DEL_LOCAL_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_lb_static_mapping_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_lb_static_mapping_dump_t;
#define VL_API_NAT44_LB_STATIC_MAPPING_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_lb_static_mapping_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_ip4_address_t external_addr;
    u16 external_port;
    u8 protocol;
    vl_api_nat_config_flags_t flags;
    u32 affinity;
    u8 tag[64];
    u32 local_num;
    vl_api_nat44_lb_addr_port_t locals[0];
} vl_api_nat44_lb_static_mapping_details_t;
#define VL_API_NAT44_LB_STATIC_MAPPING_DETAILS_IS_CONSTANT_SIZE (0)

typedef struct __attribute__ ((packed)) _vl_api_nat44_del_session {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_ip4_address_t address;
    u8 protocol;
    u16 port;
    u32 vrf_id;
    vl_api_nat_config_flags_t flags;
    vl_api_ip4_address_t ext_host_address;
    u16 ext_host_port;
} vl_api_nat44_del_session_t;
#define VL_API_NAT44_DEL_SESSION_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_del_session_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_nat44_del_session_reply_t;
#define VL_API_NAT44_DEL_SESSION_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
} vl_api_nat44_user_dump_t;
#define VL_API_NAT44_USER_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_details {
    u16 _vl_msg_id;
    u32 context;
    u32 vrf_id;
    vl_api_ip4_address_t ip_address;
    u32 nsessions;
    u32 nstaticsessions;
} vl_api_nat44_user_details_t;
#define VL_API_NAT44_USER_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_session_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_ip4_address_t ip_address;
    u32 vrf_id;
} vl_api_nat44_user_session_dump_t;
#define VL_API_NAT44_USER_SESSION_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_session_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_ip4_address_t outside_ip_address;
    u16 outside_port;
    vl_api_ip4_address_t inside_ip_address;
    u16 inside_port;
    u16 protocol;
    vl_api_nat_config_flags_t flags;
    u64 last_heard;
    u64 total_bytes;
    u32 total_pkts;
    vl_api_ip4_address_t ext_host_address;
    u16 ext_host_port;
    vl_api_ip4_address_t ext_host_nat_address;
    u16 ext_host_nat_port;
} vl_api_nat44_user_session_details_t;
#define VL_API_NAT44_USER_SESSION_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_session_v2_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_ip4_address_t ip_address;
    u32 vrf_id;
} vl_api_nat44_user_session_v2_dump_t;
#define VL_API_NAT44_USER_SESSION_V2_DUMP_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_session_v2_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_ip4_address_t outside_ip_address;
    u16 outside_port;
    vl_api_ip4_address_t inside_ip_address;
    u16 inside_port;
    u16 protocol;
    vl_api_nat_config_flags_t flags;
    u64 last_heard;
    u64 total_bytes;
    u32 total_pkts;
    vl_api_ip4_address_t ext_host_address;
    u16 ext_host_port;
    vl_api_ip4_address_t ext_host_nat_address;
    u16 ext_host_nat_port;
    bool is_timed_out;
} vl_api_nat44_user_session_v2_details_t;
#define VL_API_NAT44_USER_SESSION_V2_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_session_v3_details {
    u16 _vl_msg_id;
    u32 context;
    vl_api_ip4_address_t outside_ip_address;
    u16 outside_port;
    vl_api_ip4_address_t inside_ip_address;
    u16 inside_port;
    u16 protocol;
    vl_api_nat_config_flags_t flags;
    u64 last_heard;
    u64 time_since_last_heard;
    u64 total_bytes;
    u32 total_pkts;
    vl_api_ip4_address_t ext_host_address;
    u16 ext_host_port;
    vl_api_ip4_address_t ext_host_nat_address;
    u16 ext_host_nat_port;
    bool is_timed_out;
} vl_api_nat44_user_session_v3_details_t;
#define VL_API_NAT44_USER_SESSION_V3_DETAILS_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_nat44_user_session_v3_dump {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_ip4_address_t ip_address;
    u32 vrf_id;
} vl_api_nat44_user_session_v3_dump_t;
#define VL_API_NAT44_USER_SESSION_V3_DUMP_IS_CONSTANT_SIZE (1)

#define VL_API_NAT44_ED_PLUGIN_ENABLE_DISABLE_CRC "nat44_ed_plugin_enable_disable_be17f8dd"
#define VL_API_NAT44_ED_PLUGIN_ENABLE_DISABLE_REPLY_CRC "nat44_ed_plugin_enable_disable_reply_e8d4e804"
#define VL_API_NAT44_FORWARDING_ENABLE_DISABLE_CRC "nat44_forwarding_enable_disable_b3e225d2"
#define VL_API_NAT44_FORWARDING_ENABLE_DISABLE_REPLY_CRC "nat44_forwarding_enable_disable_reply_e8d4e804"
#define VL_API_NAT_IPFIX_ENABLE_DISABLE_CRC "nat_ipfix_enable_disable_9af4a2d2"
#define VL_API_NAT_IPFIX_ENABLE_DISABLE_REPLY_CRC "nat_ipfix_enable_disable_reply_e8d4e804"
#define VL_API_NAT_SET_TIMEOUTS_CRC "nat_set_timeouts_d4746b16"
#define VL_API_NAT_SET_TIMEOUTS_REPLY_CRC "nat_set_timeouts_reply_e8d4e804"
#define VL_API_NAT44_SET_SESSION_LIMIT_CRC "nat44_set_session_limit_8899bbb1"
#define VL_API_NAT44_SET_SESSION_LIMIT_REPLY_CRC "nat44_set_session_limit_reply_e8d4e804"
#define VL_API_NAT44_SHOW_RUNNING_CONFIG_CRC "nat44_show_running_config_51077d14"
#define VL_API_NAT44_SHOW_RUNNING_CONFIG_REPLY_CRC "nat44_show_running_config_reply_93d8e267"
#define VL_API_NAT_SET_WORKERS_CRC "nat_set_workers_da926638"
#define VL_API_NAT_SET_WORKERS_REPLY_CRC "nat_set_workers_reply_e8d4e804"
#define VL_API_NAT_WORKER_DUMP_CRC "nat_worker_dump_51077d14"
#define VL_API_NAT_WORKER_DETAILS_CRC "nat_worker_details_84bf06fc"
#define VL_API_NAT44_ED_ADD_DEL_VRF_TABLE_CRC "nat44_ed_add_del_vrf_table_08330904"
#define VL_API_NAT44_ED_ADD_DEL_VRF_TABLE_REPLY_CRC "nat44_ed_add_del_vrf_table_reply_e8d4e804"
#define VL_API_NAT44_ED_ADD_DEL_VRF_ROUTE_CRC "nat44_ed_add_del_vrf_route_59187407"
#define VL_API_NAT44_ED_ADD_DEL_VRF_ROUTE_REPLY_CRC "nat44_ed_add_del_vrf_route_reply_e8d4e804"
#define VL_API_NAT44_ED_VRF_TABLES_DUMP_CRC "nat44_ed_vrf_tables_dump_51077d14"
#define VL_API_NAT44_ED_VRF_TABLES_DETAILS_CRC "nat44_ed_vrf_tables_details_7b264e4f"
#define VL_API_NAT44_ED_VRF_TABLES_V2_DUMP_CRC "nat44_ed_vrf_tables_v2_dump_51077d14"
#define VL_API_NAT44_ED_VRF_TABLES_V2_DETAILS_CRC "nat44_ed_vrf_tables_v2_details_7b264e4f"
#define VL_API_NAT_SET_MSS_CLAMPING_CRC "nat_set_mss_clamping_25e90abb"
#define VL_API_NAT_SET_MSS_CLAMPING_REPLY_CRC "nat_set_mss_clamping_reply_e8d4e804"
#define VL_API_NAT_GET_MSS_CLAMPING_CRC "nat_get_mss_clamping_51077d14"
#define VL_API_NAT_GET_MSS_CLAMPING_REPLY_CRC "nat_get_mss_clamping_reply_1c0b2a78"
#define VL_API_NAT44_ED_SET_FQ_OPTIONS_CRC "nat44_ed_set_fq_options_2399bd71"
#define VL_API_NAT44_ED_SET_FQ_OPTIONS_REPLY_CRC "nat44_ed_set_fq_options_reply_e8d4e804"
#define VL_API_NAT44_ED_SHOW_FQ_OPTIONS_CRC "nat44_ed_show_fq_options_51077d14"
#define VL_API_NAT44_ED_SHOW_FQ_OPTIONS_REPLY_CRC "nat44_ed_show_fq_options_reply_7213b545"
#define VL_API_NAT44_ADD_DEL_INTERFACE_ADDR_CRC "nat44_add_del_interface_addr_4aed50c0"
#define VL_API_NAT44_ADD_DEL_INTERFACE_ADDR_REPLY_CRC "nat44_add_del_interface_addr_reply_e8d4e804"
#define VL_API_NAT44_INTERFACE_ADDR_DUMP_CRC "nat44_interface_addr_dump_51077d14"
#define VL_API_NAT44_INTERFACE_ADDR_DETAILS_CRC "nat44_interface_addr_details_e4aca9ca"
#define VL_API_NAT44_ADD_DEL_ADDRESS_RANGE_CRC "nat44_add_del_address_range_6f2b8055"
#define VL_API_NAT44_ADD_DEL_ADDRESS_RANGE_REPLY_CRC "nat44_add_del_address_range_reply_e8d4e804"
#define VL_API_NAT44_ADDRESS_DUMP_CRC "nat44_address_dump_51077d14"
#define VL_API_NAT44_ADDRESS_DETAILS_CRC "nat44_address_details_0d1beac1"
#define VL_API_NAT44_INTERFACE_ADD_DEL_FEATURE_CRC "nat44_interface_add_del_feature_f3699b83"
#define VL_API_NAT44_INTERFACE_ADD_DEL_FEATURE_REPLY_CRC "nat44_interface_add_del_feature_reply_e8d4e804"
#define VL_API_NAT44_INTERFACE_DUMP_CRC "nat44_interface_dump_51077d14"
#define VL_API_NAT44_INTERFACE_DETAILS_CRC "nat44_interface_details_5d286289"
#define VL_API_NAT44_ED_ADD_DEL_OUTPUT_INTERFACE_CRC "nat44_ed_add_del_output_interface_47d6e753"
#define VL_API_NAT44_ED_ADD_DEL_OUTPUT_INTERFACE_REPLY_CRC "nat44_ed_add_del_output_interface_reply_e8d4e804"
#define VL_API_NAT44_ED_OUTPUT_INTERFACE_GET_CRC "nat44_ed_output_interface_get_f75ba505"
#define VL_API_NAT44_ED_OUTPUT_INTERFACE_GET_REPLY_CRC "nat44_ed_output_interface_get_reply_53b48f5d"
#define VL_API_NAT44_ED_OUTPUT_INTERFACE_DETAILS_CRC "nat44_ed_output_interface_details_0b45011c"
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_CRC "nat44_add_del_static_mapping_5ae5f03e"
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_REPLY_CRC "nat44_add_del_static_mapping_reply_e8d4e804"
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_V2_CRC "nat44_add_del_static_mapping_v2_5e205f1a"
#define VL_API_NAT44_ADD_DEL_STATIC_MAPPING_V2_REPLY_CRC "nat44_add_del_static_mapping_v2_reply_e8d4e804"
#define VL_API_NAT44_STATIC_MAPPING_DUMP_CRC "nat44_static_mapping_dump_51077d14"
#define VL_API_NAT44_STATIC_MAPPING_DETAILS_CRC "nat44_static_mapping_details_06cb40b2"
#define VL_API_NAT44_ADD_DEL_IDENTITY_MAPPING_CRC "nat44_add_del_identity_mapping_02faaa22"
#define VL_API_NAT44_ADD_DEL_IDENTITY_MAPPING_REPLY_CRC "nat44_add_del_identity_mapping_reply_e8d4e804"
#define VL_API_NAT44_IDENTITY_MAPPING_DUMP_CRC "nat44_identity_mapping_dump_51077d14"
#define VL_API_NAT44_IDENTITY_MAPPING_DETAILS_CRC "nat44_identity_mapping_details_2a52a030"
#define VL_API_NAT44_ADD_DEL_LB_STATIC_MAPPING_CRC "nat44_add_del_lb_static_mapping_4f68ee9d"
#define VL_API_NAT44_ADD_DEL_LB_STATIC_MAPPING_REPLY_CRC "nat44_add_del_lb_static_mapping_reply_e8d4e804"
#define VL_API_NAT44_LB_STATIC_MAPPING_ADD_DEL_LOCAL_CRC "nat44_lb_static_mapping_add_del_local_7ca47547"
#define VL_API_NAT44_LB_STATIC_MAPPING_ADD_DEL_LOCAL_REPLY_CRC "nat44_lb_static_mapping_add_del_local_reply_e8d4e804"
#define VL_API_NAT44_LB_STATIC_MAPPING_DUMP_CRC "nat44_lb_static_mapping_dump_51077d14"
#define VL_API_NAT44_LB_STATIC_MAPPING_DETAILS_CRC "nat44_lb_static_mapping_details_ed5ce876"
#define VL_API_NAT44_DEL_SESSION_CRC "nat44_del_session_15a5bf8c"
#define VL_API_NAT44_DEL_SESSION_REPLY_CRC "nat44_del_session_reply_e8d4e804"
#define VL_API_NAT44_USER_DUMP_CRC "nat44_user_dump_51077d14"
#define VL_API_NAT44_USER_DETAILS_CRC "nat44_user_details_355896c2"
#define VL_API_NAT44_USER_SESSION_DUMP_CRC "nat44_user_session_dump_e1899c98"
#define VL_API_NAT44_USER_SESSION_DETAILS_CRC "nat44_user_session_details_2cf6e16d"
#define VL_API_NAT44_USER_SESSION_V2_DUMP_CRC "nat44_user_session_v2_dump_e1899c98"
#define VL_API_NAT44_USER_SESSION_V2_DETAILS_CRC "nat44_user_session_v2_details_fd42b729"
#define VL_API_NAT44_USER_SESSION_V3_DETAILS_CRC "nat44_user_session_v3_details_edae926e"
#define VL_API_NAT44_USER_SESSION_V3_DUMP_CRC "nat44_user_session_v3_dump_e1899c98"

#endif
