#ifndef included_rdma_api_types_h
#define included_rdma_api_types_h
#define VL_API_RDMA_API_VERSION_MAJOR 3
#define VL_API_RDMA_API_VERSION_MINOR 0
#define VL_API_RDMA_API_VERSION_PATCH 0
/* Imported API files */
#include <vnet/interface_types.api_types.h>
typedef enum {
    RDMA_API_MODE_AUTO = 0,
    RDMA_API_MODE_IBV = 1,
    RDMA_API_MODE_DV = 2,
} vl_api_rdma_mode_t;
typedef enum {
    RDMA_API_RSS4_AUTO = 0,
    RDMA_API_RSS4_IP = 1,
    RDMA_API_RSS4_IP_UDP = 2,
    RDMA_API_RSS4_IP_TCP = 3,
} vl_api_rdma_rss4_t;
typedef enum {
    RDMA_API_RSS6_AUTO = 0,
    RDMA_API_RSS6_IP = 1,
    RDMA_API_RSS6_IP_UDP = 2,
    RDMA_API_RSS6_IP_TCP = 3,
} vl_api_rdma_rss6_t;
typedef struct __attribute__ ((packed)) _vl_api_rdma_create {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 host_if[64];
    u8 name[64];
    u16 rxq_num;
    u16 rxq_size;
    u16 txq_size;
    vl_api_rdma_mode_t mode;
} vl_api_rdma_create_t;
#define VL_API_RDMA_CREATE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_create_v2 {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 host_if[64];
    u8 name[64];
    u16 rxq_num;
    u16 rxq_size;
    u16 txq_size;
    vl_api_rdma_mode_t mode;
    bool no_multi_seg;
    u16 max_pktlen;
} vl_api_rdma_create_v2_t;
#define VL_API_RDMA_CREATE_V2_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_create_v3 {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 host_if[64];
    u8 name[64];
    u16 rxq_num;
    u16 rxq_size;
    u16 txq_size;
    vl_api_rdma_mode_t mode;
    bool no_multi_seg;
    u16 max_pktlen;
    vl_api_rdma_rss4_t rss4;
    vl_api_rdma_rss6_t rss6;
} vl_api_rdma_create_v3_t;
#define VL_API_RDMA_CREATE_V3_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_create_v4 {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    u8 host_if[64];
    u8 name[64];
    u16 rxq_num;
    u16 rxq_size;
    u16 txq_size;
    vl_api_rdma_mode_t mode;
    bool no_multi_seg;
    u16 max_pktlen;
    vl_api_rdma_rss4_t rss4;
    vl_api_rdma_rss6_t rss6;
} vl_api_rdma_create_v4_t;
#define VL_API_RDMA_CREATE_V4_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_create_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_interface_index_t sw_if_index;
} vl_api_rdma_create_reply_t;
#define VL_API_RDMA_CREATE_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_create_v2_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_interface_index_t sw_if_index;
} vl_api_rdma_create_v2_reply_t;
#define VL_API_RDMA_CREATE_V2_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_create_v3_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_interface_index_t sw_if_index;
} vl_api_rdma_create_v3_reply_t;
#define VL_API_RDMA_CREATE_V3_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_create_v4_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
    vl_api_interface_index_t sw_if_index;
} vl_api_rdma_create_v4_reply_t;
#define VL_API_RDMA_CREATE_V4_REPLY_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_delete {
    u16 _vl_msg_id;
    u32 client_index;
    u32 context;
    vl_api_interface_index_t sw_if_index;
} vl_api_rdma_delete_t;
#define VL_API_RDMA_DELETE_IS_CONSTANT_SIZE (1)

typedef struct __attribute__ ((packed)) _vl_api_rdma_delete_reply {
    u16 _vl_msg_id;
    u32 context;
    i32 retval;
} vl_api_rdma_delete_reply_t;
#define VL_API_RDMA_DELETE_REPLY_IS_CONSTANT_SIZE (1)

#define VL_API_RDMA_CREATE_CRC "rdma_create_076fe418"
#define VL_API_RDMA_CREATE_V2_CRC "rdma_create_v2_5826a4f3"
#define VL_API_RDMA_CREATE_V3_CRC "rdma_create_v3_c6287ea8"
#define VL_API_RDMA_CREATE_V4_CRC "rdma_create_v4_c6287ea8"
#define VL_API_RDMA_CREATE_REPLY_CRC "rdma_create_reply_5383d31f"
#define VL_API_RDMA_CREATE_V2_REPLY_CRC "rdma_create_v2_reply_5383d31f"
#define VL_API_RDMA_CREATE_V3_REPLY_CRC "rdma_create_v3_reply_5383d31f"
#define VL_API_RDMA_CREATE_V4_REPLY_CRC "rdma_create_v4_reply_5383d31f"
#define VL_API_RDMA_DELETE_CRC "rdma_delete_f9e6675e"
#define VL_API_RDMA_DELETE_REPLY_CRC "rdma_delete_reply_e8d4e804"

#endif
